<?php
defined('_JEXEC') or die;

jimport('joomla.application.component.controllerform');

class IgalleryControllerImage extends JControllerForm
{
	function __construct($config = array())
	{
		parent::__construct($config);
		$this->registerTask('save_and_next', 'save');
	}
	
	function save()
	{
		$data = JRequest::getVar('jform', array(), 'post' ,'NONE', 4);
		$id = (int)$data['id'];
			
		if(!igGeneralHelper::authorise('core.edit', null, $id))
		{
			return JError::raiseWarning(404, JText::_('JERROR_ALERTNOAUTHOR'));
		}
		
		$model = $this->getModel();
		
		$nextOrder = $model->save($data);
		
		switch($this->task)
		{
			case 'apply':
			$url = 'index.php?option=com_igallery&view=image&id='.$id;
			break;
			
			case 'save_and_next':
			$url = empty($nextOrder) ? $url = 'index.php?option=com_igallery&view=images&catid='.JRequest::GetInt('catid') : 'index.php?option=com_igallery&view=image&id='.$nextOrder;
			break;
			
			case 'save':
			$url = 'index.php?option=com_igallery&view=images&catid='.JRequest::GetInt('catid');
		}
		
		$this->setRedirect( JRoute::_($url, false), JText::_('SUCCESSFULLY_SAVED'));
	}

    function addvideo()
    {
        if(!igGeneralHelper::authorise('core.create', JRequest::getInt('catid', 0) ) )
        {
            echo JText::_('JERROR_ALERTNOAUTHOR');
            return false;
        }

        if(!function_exists('curl_version'))
        {
            JError::raiseWarning(404, JText::_('Error: Curl Support is not enabled in php.ini, please see the gallery documentation - common sections question about Curl Support. You can also upload an image and copy the embed code from youtube or vimeo to the images embed field.'));
            return false;
        }

        if( !ini_get('allow_url_fopen') )
        {
            JError::raiseWarning(404, JText::_('Error: allow_url_fopen is not enabled in php.ini, please see the gallery documentation - common sections question about allow_url_fopen Support. You can also upload an image and copy the embed code from youtube or vimeo to the images embed field.'));
            return false;
        }

        $videoUrl = JRequest::getVar('addvideo_url','');

        if(!$fileData = igFileHelper::processVideoUrl($videoUrl) )
        {
            return false;
        }

        $model = $this->getModel();


        if (!$model->store($fileData) )
        {
            return false;
        }

        $url = 'index.php?option=com_igallery&view=images&catid='.JRequest::GetInt('catid');
        $this->setRedirect( JRoute::_($url, false), JText::_('SUCCESSFULLY_SAVED'));
    }
	
	function cancel()
	{
		$this->setRedirect( JRoute::_('index.php?option=com_igallery&view=images&catid='.JRequest::GetInt('catid'), false) );
	}
}