<?php
defined('JPATH_BASE') or die;

jimport('joomla.html.html');
jimport('joomla.form.formfield');

class JFormFieldIcategory extends JFormField
{
	protected $type = 'Icategory';

	protected function getInput()
	{
        require_once(JPATH_ADMINISTRATOR.'/components/com_igallery/helpers/tree.php');
        require_once(JPATH_ADMINISTRATOR.'/components/com_igallery/helpers/static.php');
		$option = JRequest::getVar('option');
        $hideCurrent = false;

		if($option == 'com_config')
		{
			$params = JComponentHelper::getParams('com_igallery');
			$selected = $params->get('default_parent', 0);
		}
		else if($option == 'com_menus')
		{
			$selected = $this->value;
		}
		else if(strpos($option, 'module') )
		{
			$igparams = $this->form->getValue('params');
			$selected = isset($igparams->category_id) ? $igparams->category_id : 0;
		}
		else
		{
			$selected = $this->form->getValue('parent');
			$hideCurrent = true;
		} 
		
		$categories = igStaticHelper::getCategories();
        $categoriesbyTree = igTreeHelper::makeCategoryTree($categories);

        if($hideCurrent)
        {
            $current = JRequest::getInt('id',0);
            $categoriesbyTree = igTreeHelper::removeFromTree($categoriesbyTree, 'id', $current, 'numeric-exist');
        }

        if($option == 'com_igallery' && JRequest::getVar('view') == 'icategory' && JRequest::getInt('id', 0) > 0 )
        {
            $children = igTreeHelper::getChildIds($categories, JRequest::getInt('id', 0), true);

            if( count($children) > 0)
            {
                foreach($children as $child)
                {
                    $categoriesbyTree = igTreeHelper::removeFromTree($categoriesbyTree, 'id', $child, 'numeric-exist');
                }
            }
        }

	    $selectItems = array();
	    
	    if($option != 'com_menus' && !strpos($option, 'module') && JRequest::getVar('view') != 'editorbutton')
	    {
	    	$selectItems[]   = JHTML::_('select.option', '0', JText::_('JGLOBAL_TOP') );
	    }

	    foreach ($categoriesbyTree as $category)
	    {
            $displayName = $category->name;
            for($k=0; $k<$category->level; $k++)
            {
                $displayName  = ' - '.$displayName;
            }
	        $selectItems[] = JHTML::_('select.option', $category->id, $displayName );
	    }
		
	    $selectHTML = JHTML::_("select.genericlist", $selectItems, $this->name, 'class="inputbox" size="14"',
	    'value', 'text', $selected);

        $js = "
        <script>
        jQuery(document).ready(function($)
        {
            if( $('#jform_params_module_gallery_type').length)
            {
                if($('#jform_params_module_gallery_type').find('option:selected').val() == 'tags_cloud')
                {
                    $('#jform_params_category_id-lbl, #jformparamscategory_id_chzn, #jform_params_ig_children-lbl, #jform_params_ig_children, #jform_params_add_links-lbl, #jform_params_add_links, #jform_params_profile_id-lbl, #jformparamsprofile_id_chzn, #jform_params_ig_tag-lbl, #jform_params_ig_tag, #jform_params_ig_photo_limit-lbl, #jform_params_ig_photo_limit').css('display','none');
                }
        
                $('#jform_params_module_gallery_type').change(function()
                {
                    var val = $(this).find('option:selected').val();
                    if(val == 'tags_cloud')
                    {
                        $('#jform_params_category_id-lbl, #jformparamscategory_id_chzn, #jform_params_ig_children-lbl, #jform_params_ig_children, #jform_params_add_links-lbl, #jform_params_add_links, #jform_params_profile_id-lbl, #jformparamsprofile_id_chzn, #jform_params_ig_tag-lbl, #jform_params_ig_tag, #jform_params_ig_photo_limit-lbl, #jform_params_ig_photo_limit').css('display','none');
                    }
                    else
                    {
                        $('#jform_params_category_id-lbl, #jformparamscategory_id_chzn, #jform_params_ig_children-lbl, #jform_params_ig_children, #jform_params_add_links-lbl, #jform_params_add_links, #jform_params_profile_id-lbl, #jformparamsprofile_id_chzn, #jform_params_ig_tag-lbl, #jform_params_ig_tag, #jform_params_ig_photo_limit-lbl, #jform_params_ig_photo_limit').css('display','block');
                    }
                });
            }
        });
        </script>";

        $selectHTML = $selectHTML.$js;
        return $selectHTML;
	}
}