<?php
defined('_JEXEC') or die('Restricted access');

class igUtilityHelper
{
    static function makeImageUrl($url, $imgString)
    {
        if(strpos($url,'?') === false)
        {
            return $url.'?i='.$imgString;
        }
        else
        {
            return $url.'&i='.$imgString;
        }
    }

    static function timeElapsedString($timestamp, $full = false)
    {
        $datetime = date('Y-m-d H:i:s', $timestamp);
        $now = new DateTime;
        $ago = new DateTime($datetime);
        $diff = $now->diff($ago);

        $diff->w = floor($diff->d / 7);
        $diff->d -= $diff->w * 7;

        $string = array
        (
            'y' => 'year',
            'm' => 'month',
            'w' => 'week',
            'd' => 'day',
            'h' => 'hour',
            'i' => 'minute',
            's' => 'second',
        );

        foreach($string as $k => &$v)
        {
            if($diff->$k)
            {
                $v = $diff->$k . ' ' . $v . ($diff->$k > 1 ? 's' : '');
            }
            else
            {
                unset($string[$k]);
            }
        }

        if(!$full)
        {
            $string = array_slice($string, 0, 1);
        }

        return $string ? implode(', ', $string) . ' ago' : 'just now';
    }

    static function writeBreadcrumbs($category)
    {
        $app	= JFactory::getApplication();
        $pathway = $app->getPathway();
        $breadCrumbNames = array();
        $breadCrumbLinks = array();
        $Itemid = JRequest::getInt('Itemid', 0);
        $catIdOfActive = 0;

        if( $Itemid > 0 )
        {
            $menu	= $app->getMenu();
            $activeMenu = $menu->getItem($Itemid);
            if( isset($activeMenu->query['igid']) )
            {
                $catIdOfActive = $activeMenu->query['igid'];
            }
        }

        $categories = igStaticHelper::getCategories();
        $parents = igTreeHelper::getParentPath($categories, $category->id, true);

        foreach($parents as $parent)
        {
            if($parent->id != $catIdOfActive)
            {
                array_unshift($breadCrumbNames, $parent->name);
                if($parent->id != $category->id)
                {
                    array_unshift($breadCrumbLinks, JRoute::_('index.php?option=com_igallery&view=category&igid='.$parent->id.'&Itemid='.JRequest::getInt('Itemid', '') ) );
                }
                else
                {
                    array_unshift($breadCrumbLinks, '');
                }
            }
            else
            {
                break;
            }
        }

        for($i=0; $i<count($breadCrumbNames); $i++)
        {
            $pathway->addItem($breadCrumbNames[$i], $breadCrumbLinks[$i]);
        }
    }

    static function getItemid($catId, $tags=false)
    {
        $app = JFactory::getApplication();
        $menu = $app->getMenu();
        $menuItems = $menu->getMenu();
        $currentLang = JFactory::getLanguage()->getTag();

        if($tags)
        {
            foreach($menuItems as $menu)
            {
                if($currentLang == $menu->language && $menu->component == 'com_igallery' && $menu->query['view'] == 'tags')
                {
                    return $menu->id;
                }
            }

            foreach($menuItems as $menu)
            {
                if($menu->component == 'com_igallery' && $menu->query['view'] == 'tags')
                {
                    return $menu->id;
                }
            }
        }

        $categories = igStaticHelper::getCategories();
        $parents = igTreeHelper::getParentPath($categories, $catId, false);

        foreach($menuItems as $menu)
        {
            if($currentLang == $menu->language && $menu->component == 'com_igallery' && $menu->query['view'] == 'category' && $menu->query['igid'] == $catId)
            {
                return $menu->id;
            }
        }

        foreach($menuItems as $menu)
        {
            if($menu->component == 'com_igallery' && $menu->query['view'] == 'category' && $menu->query['igid'] == $catId)
            {
                return $menu->id;
            }
        }

        foreach($menuItems as $menu)
        {
            if($currentLang == $menu->language && $menu->component == 'com_igallery' && $menu->query['view'] == 'category')
            {
                foreach($parents as $parent)
                {
                    if($parent->id == $menu->query['igid'])
                    {
                        return $menu->id;
                    }
                }
            }
        }

        foreach($menuItems as $menu)
        {
            if($menu->component == 'com_igallery' && $menu->query['view'] == 'category')
            {
                foreach($parents as $parent)
                {
                    if($parent->id == $menu->query['igid'])
                    {
                        return $menu->id;
                    }
                }
            }
        }

        return JRequest::getInt('Itemid', 1);
    }

    static function clean($text)
    {
        return htmlentities(strip_tags($text),ENT_QUOTES);
    }

    static function getDescriptionText($textToInsert, $row)
    {
        $displayText = '';

        if($textToInsert == 'full' || $textToInsert == 'full_below')
        {
            preg_match_all('/-[0-9]+/', $row->filename, $matches);
            $displayText = str_replace($matches[0][0], '', $row->filename);
            $displayText = str_replace(array('.jpg','.jpeg','.gif','.png'), '', $displayText);
            $displayText = str_replace('_',' ',$displayText);
        }

        if($textToInsert == 'alt-text' || $textToInsert == 'alt' || $textToInsert == 'alt_below')
        {
            $displayText = $row->alt_text;
        }

        if($textToInsert == 'description' || $textToInsert == 'description_below')
        {
            $displayText = $row->description;
        }

        return $displayText;
    }

    static function shuffleAssoc($list)
    {
        $keys = array_keys($list);
        shuffle($keys);
        $random = array();
        foreach($keys as $key)
        {
            $random[$key] = $list[$key];
        }
        return $random;
    }
}
