<?php
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

class igalleryViewcategory extends JViewLegacy
{
    public function __construct($config = array())
    {
        $config['template_path'] = JPATH_SITE.'/components/com_igallery/views/category/tmpl';
        parent::__construct($config);
    }

    function display($tpl = null)
	{
	    $this->removeCanonical();

        $app = JFactory::getApplication();
        $this->user = JFactory::getUser();
	    $this->guest = $this->user->get('guest') ? true : false;
        $this->params = JComponentHelper::getParams('com_igallery');
	    $model = $this->getModel();
        $this->languageTag = JFactory::getLanguage()->getTag();
        $this->currentUrl = JFactory::getURI()->toString();
        $this->activeImage = 0;
        $this->source = JRequest::getCmd('igsource', 'component');
		$this->catid = JRequest::getInt('igid', 0);
        $tags = JRequest::getVar('igtags', '');
    	$searchChildren = JRequest::getInt('igchild', 0);
    	if(strlen($tags) > 0){$searchChildren=1;}

    	$this->type = JRequest::getCmd('igtype', 'category');
    	$profileId = JRequest::getInt('igpid', 0);
    	$this->Itemid = JRequest::getInt('Itemid', '');
    	$this->ajaxUrlImageName = JRequest::getCmd('i', '');
        $this->urlImageName = JRequest::getCmd('image', '');
        $limit = JRequest::getInt('iglimit', 0);
        $limit = $limit == 0 ? 1000 : $limit;
        $uniqueid = JRequest::getCmd('iguniqueid', 0);
        $this->uniqueid = !empty($uniqueid) ? $uniqueid : $this->catid;
        $this->hasTags = false;
        $this->currentUrl = JFactory::getURI()->toString();
        $this->currentUrl = strpos($this->currentUrl, '&i=') !== false ? substr($this->currentUrl, 0, strpos($this->currentUrl, '&i=')) : $this->currentUrl;
        $this->currentUrl = strpos($this->currentUrl, '?i=') !== false ? substr($this->currentUrl, 0, strpos($this->currentUrl, '?i=')) : $this->currentUrl;


        if($this->source != 'component')
		{
			$overridePath = JPATH_BASE.'/templates/'.$app->getTemplate().'/html/com_igallery/'.$this->getName();
			$this->_addPath('template', $overridePath);
		}

        $this->category = $model->getCategory($this->catid);

		if($this->category == null)
	    {
	    	JError::raise(2, 404, 'Error the gallery with an id of: '.$this->catid.' is not published' );
	        return;
	    }

        if( !empty( trim($this->category->password) ) && JFactory::getSession()->get('igpassword.'.$this->category->id, '') != 'correct')
        {
            $this->setMetaData(true);
            parent::display('password_form');
            return true;
        }

        $profileId = $profileId == 0 ? $this->category->profile : $profileId;
		$this->profile = $model->getProfile($profileId);

		if($this->profile == null)
		{
			JError::raise(2, 404, JText::_('Profile Unpublished') );
			return;
		}

		if($this->profile->show_large_image == 0 && $this->profile->show_thumbs == 0)
		{
			JError::raise(2, 500, JText::_('Thumbs or main image display must be enabled in profile settings') );
			return;
		}

        $this->profile->refresh_mode = $this->source == 'module' ? 'javascript' : $this->profile->refresh_mode;
        $this->profile->refresh_mode = JRequest::getInt('igplugincalled', 0) == 1 ? 'javascript' : $this->profile->refresh_mode;


        if($this->source == 'plugin')
		{
			JRequest::setVar('igplugincalled', 1);
		}

		$this->registerLink = $this->params->get('register_link', 'index.php?option=com_user&amp;task=register');

        if($this->profile->access == 999)
        {
            $owners = array();
            $owners[] = $this->category->user;
            if(!empty($this->category->second_user)){$owners[] = $this->category->second_user;}
            if(!empty($this->category->third_user)){$owners[] = $this->category->third_user;}
            if(!empty($this->category->fourth_user)){$owners[] = $this->category->fourth_user;}

            if(!in_array($this->user->id, $owners))
            {
                return JError::raiseWarning(404, JText::_('JERROR_ALERTNOAUTHOR'));
            }
        }
        else if( !in_array($this->profile->access, $this->user->getAuthorisedViewLevels() ) )
		{
			if($this->profile->access == 2)
			{
                JFactory::getApplication()->redirect( JRoute::_($this->registerLink.'&return='.urlencode(base64_encode(JFactory::getURI()->toString())),false ), JText::_( 'PLEASE_LOGIN_TO_VIEW' ));
                return;
			}
			else
			{
				return JError::raiseWarning(404, JText::_('JERROR_ALERTNOAUTHOR'));
			}
		}

        if( ($this->source == 'component' && JRequest::getVar('igtags', '') == '') || $this->type == 'child_menu_images' || $this->type == 'latest_menu_images' || $this->type == 'hits_menu_images' || $this->type == 'random_menu_images')
        {
            $this->categoryChildren = $model->getCategoryChildren($this->catid, $this->profile, $this->type, $this->source, $limit);
        }
        else
        {
            $this->categoryChildren = null;
        }

        if($this->source == 'component' || $this->type == 'category' || $this->type == 'latest' || $this->type == 'hits' || $this->type == 'rated' || $this->type == 'random')
        {
            switch($this->type)
            {
                case 'random' : $this->photoList = $model->getRandomList($this->profile, $this->catid, $tags, $searchChildren, $limit);break;
                case 'latest' : $this->photoList = $model->getLatestList($this->profile, $this->catid, $tags, $searchChildren, $limit);break;
                case 'hits'   : $this->photoList = $model->getHitsList($this->profile, $this->catid, $tags, $searchChildren, $limit);break;
                case 'rated'  : $this->photoList = $model->getRatedList($this->profile, $this->catid, $tags, $searchChildren, $limit);break;
                default       : $this->photoList = $model->getCategoryImagesList($this->profile, $this->catid, $tags, $searchChildren, $limit);
            }
        }
        else
        {
            $this->photoList =  array();
        }

        if($this->profile->allow_comments == 1 || $this->profile->lbox_allow_comments == 1)
		{
			$this->photoList = $model->addComments($this->photoList);
		}

        if( empty($this->photoList) && empty($this->categoryChildren) )
        {
            if (JRequest::getVar('view', 'category') == 'tags')
            {
                if(empty($tags))
                {
                    echo '<div class="alert alert-info"><div class="alert-message">This menu item will be used when an image tag is clicked on. Please put this menu item on a hidden menu. See the common questions in the gallery documentation for more info.</div></div>';
                }
                else
                {
                    echo '<div class="alert alert-info"><div class="alert-message">No Images with the tag: '.$tags.' found</div></div>';
                }
            }
            else
            {
                echo '<div class="alert alert-info"><div class="alert-message">Notice: No Images or Galleries Found</div></div>';
            }
        }

    	if($this->profile->menu_pagination == 1 && count($this->categoryChildren) )
    	{
	        $this->menuPagination = $model->getPagination($model->menuTotal, $this->profile->menu_pagination_amount, 'menu_');
    	}
    	if($this->profile->thumb_pagination == 1 && $this->photoList != null )
    	{
	        $this->thumbPagination = $model->getPagination($model->thumbTotal,$this->profile->thumb_pagination_amount, 'thumb_');
    	}

		$this->thumbFiles = array();
		$this->mainFiles = array();
		$this->lboxFiles = array();
		$this->lboxThumbFiles = array();

		$this->desVars = new stdClass();
        $this->desVars->mainHasDescriptions = null;

		if( !empty($this->photoList) )
		{
            $this->desVars->mainHasDescriptions = $this->profile->show_filename == 'none' ? false : true;
    	    $this->desVars->lboxHasDescriptions = $this->profile->lbox_show_filename == 'none' ? false : true;

            $this->desVars->mainHasDescriptions = ($this->profile->allow_comments == 4 && $this->profile->comments_position == 'match_descriptions') ? true : $this->desVars->mainHasDescriptions;
            $this->desVars->lboxHasDescriptions = ($this->profile->lbox_allow_comments == 4 && $this->profile->lbox_comments_position == 'match_descriptions') ? true : $this->desVars->lboxHasDescriptions;


            if($this->profile->thumb_grid_type == 'metro' && $this->profile->thumb_layout == 'grid')
            {
                $ratios = array();
                $targetTallImages = round( count($this->photoList)/12 );
                $targetWideImages = round( count($this->photoList)/12 );
                $targetBigImages = round( count($this->photoList)/12 );

                for($i=0; $i<count($this->photoList); $i++)
                {
                    $row = $this->photoList[$i];
                    $increment = igFileHelper::getIncrementFromFilename($row->filename);
                    $folderName = igFileHelper::getFolderName($increment);
                    $sourceFile = IG_ORIG_PATH.'/'.$folderName.'/'.$row->filename;
                    $imgSize = getimagesize($sourceFile);
                    $ratios[$i] = $imgSize[0]/$imgSize[1];
                }

                //$ratios = igUtilityHelper::shuffleAssoc($ratios);

                asort($ratios);
                $tallIndexes = array();
                $ratiosForTall = $ratios;
                for($k=0; $k<$targetTallImages; $k++)
                {
                    $key = key($ratiosForTall);
                    $tallIndexes[] = $key;
                    unset($ratiosForTall[$key]);
                }

                arsort($ratios);
                $wideIndexes = array();
                $ratiosForWide = $ratios;
                for($k=0; $k<$targetWideImages; $k++)
                {
                    $key = key($ratiosForWide);
                    $wideIndexes[] = $key;
                    unset($ratiosForWide[$key]);
                }

                $bigIndexes = array();
                $keys = array_keys($ratios);
                for($k=0; $k<$targetBigImages; $k++)
                {
                    $index = $keys[round(count($keys)/2)];

                    $bigIndexes[] = $index;
                    unset($keys[$index]);
                    $keys = array_values($keys);
                }
            }


            for($i=0; $i<count($this->photoList); $i++)
    		{
    		    $row = $this->photoList[$i];

                if($this->profile->show_tags == 1 || $this->profile->lbox_show_tags == 1)
                {
                    if( strlen($row->tags) > 0 )
                    {
                        $this->hasTags = true;
                        $tagsString = '<div class="ig-tags-wrapper">';
                        $tagsArray = explode(',', $row->tags);
                        for($k=0; $k<count($tagsArray); $k++)
                        {
                            $tagsString .= '<a class="ig-tags-link" href="'.JRoute::_('index.php?option=com_igallery&view=tags&igtags='.$tagsArray[$k].'&Itemid='.igUtilityHelper::getItemid($this->category->id,true)).'">'.$tagsArray[$k].'</a> ';
                        }
                        $tagsString .= '</div>';
                        $row->description .= $tagsString;
                    }

                    if($this->hasTags == true)
                    {
                        $this->desVars->mainHasDescriptions = true;
                    }
                }

                if($this->profile->thumb_grid_type == 'metro' && $this->profile->thumb_layout == 'grid')
                {
                    $smaller = min($this->profile->thumb_width,$this->profile->thumb_height);

                    $this->profile->thumb_width = $smaller;
                    $this->profile->thumb_height = $smaller;
                    $this->profile->crop_thumbs = 1;

                    $row->thumbHeightDouble = 0;
                    $row->thumbWidthDouble = 0;
                    $this->profile->crop_thumbs = 1;

                    if( in_array($i,$tallIndexes))
                    {
                        $thumbHeight = ($this->profile->thumb_height * 2) + $this->profile->thumb_grid_spacing;
                        $thumbWidth = $this->profile->thumb_width;
                        $row->thumbHeightDouble = 1;
                    }
                    else if( in_array($i,$wideIndexes))
                    {
                        $thumbWidth = ($this->profile->thumb_width * 2) + $this->profile->thumb_grid_spacing;
                        $thumbHeight = $this->profile->thumb_height;
                        $row->thumbWidthDouble = 1;
                    }
                    else if( in_array($i,$bigIndexes))
                    {
                        $thumbWidth = ($this->profile->thumb_width * 2) + $this->profile->thumb_grid_spacing;
                        $thumbHeight = ($this->profile->thumb_height * 2) + $this->profile->thumb_grid_spacing;
                        $row->thumbHeightDouble = 1;
                        $row->thumbWidthDouble = 1;
                    }
                    else
                    {
                        $thumbWidth = $this->profile->thumb_width;
                        $thumbHeight = $this->profile->thumb_height;
                    }
                }
                else
                {
                    $thumbWidth = $this->profile->thumb_width;
                    $thumbHeight = $this->profile->thumb_height;
                }

    			if(! $this->thumbFiles[$i] = igFileHelper::originalToResized($row->filename, $thumbWidth,
                $thumbHeight, $this->profile->img_quality, $this->profile->crop_thumbs, $row->rotation, $this->profile->round_thumb,
                $this->profile->round_fill,$row->crop_position) )
    		    {
    		        return false;
    		    }

    		    if(! $this->mainFiles[$i] = igFileHelper::originalToResized($row->filename, $this->profile->max_width,
    		    $this->profile->max_height, $this->profile->img_quality, $this->profile->crop_main, $row->rotation, $this->profile->round_large, $this->profile->round_fill,
                $row->crop_position, $this->profile->watermark, $this->profile->watermark_text, $this->profile->watermark_text_color, $this->profile->watermark_text_size, $this->profile->watermark_filename,
    		    $this->profile->watermark_position, $this->profile->watermark_transparency, 0) )
    		    {
    		        return false;
    		    }

    		    if(! $this->lboxThumbFiles[$i] = igFileHelper::originalToResized($row->filename, $this->profile->lbox_thumb_width,
    		    $this->profile->lbox_thumb_height, $this->profile->img_quality, $this->profile->lbox_crop_thumbs, $row->rotation, $this->profile->round_thumb,
                $this->profile->round_fill, $row->crop_position) )
    		    {
    		        return false;
    		    }

    		    if(! $this->lboxFiles[$i] = igFileHelper::originalToResized($row->filename, $this->profile->lbox_max_width,
    		    $this->profile->lbox_max_height, $this->profile->img_quality, $this->profile->crop_lbox, $row->rotation, $this->profile->round_large, $this->profile->round_fill,
                $row->crop_position, $this->profile->watermark, $this->profile->watermark_text, $this->profile->watermark_text_color, $this->profile->watermark_text_size,  $this->profile->watermark_filename,
    		    $this->profile->watermark_position, $this->profile->watermark_transparency, 0) )
    		    {
    		        return false;
    		    }

    		    if( strlen($row->description) > 0 )
    		    {
    		    	$this->desVars->mainHasDescriptions = true;
    		    	$this->desVars->lboxHasDescriptions = true;
    		    }

                if(empty($row->alt_text))
                {
                    preg_match_all('/-[0-9]+/', $row->filename, $matches);
                    $altText = str_replace($matches[0][0], '', $row->filename);
                    $row->alt_text = str_replace('_',' ',JFile::stripExt($altText));
                }
    		}

		}

        $this->largestHeight = 0;
        $this->largestWidth = 0;
        $this->largestLboxHeight = 0;
        $this->largestLboxWidth = 0;

        for ($i=0; $i<count($this->mainFiles); $i++)
        {
            $this->largestWidth = $this->mainFiles[$i]['width'] > $this->largestWidth ? $this->mainFiles[$i]['width'] : $this->largestWidth;
            $this->largestHeight = $this->mainFiles[$i]['height'] > $this->largestHeight ? $this->mainFiles[$i]['height'] : $this->largestHeight;
            $this->largestLboxWidth = $this->lboxFiles[$i]['width'] > $this->largestLboxWidth ? $this->lboxFiles[$i]['width'] : $this->largestLboxWidth;
            $this->largestLboxHeight = $this->lboxFiles[$i]['height'] > $this->largestLboxHeight ? $this->lboxFiles[$i]['height'] : $this->largestLboxHeight;
        }

        if(!empty($this->photoList) && JRequest::getInt('igaddlinks', 0) == 1)
        {
            for($i=0; $i<count($this->photoList); $i++)
            {
                $row = $this->photoList[$i];

                if(strlen($row->link) < 2)
                {
                    $limitStart = '';
                    if ($row->thumb_pagination == 1)
                    {
                        if($row->ordering > $row->thumb_pagination_amount)
                        {
                            $group = ceil($row->ordering / $row->thumb_pagination_amount) - 1;

                            if($group > 0)
                            {
                                $limitStart = '&thumb_limitstart=' . ($group * $row->thumb_pagination_amount);
                            }
                        }
                    }
                    $fileHashNoExt = JFile::stripExt($row->filename);
                    $fileHashNoRef = '&i='.substr($fileHashNoExt, 0, strrpos($fileHashNoExt, '-'));
                    $linkItemid = igUtilityHelper::getItemid($row->gallery_id);
                    $this->photoList[$i]->link = JRoute::_('index.php?option=com_igallery&view=category&igid=' . $row->gallery_id . '&Itemid=' . $linkItemid . $limitStart . $fileHashNoRef, false);
                    $this->photoList[$i]->target_blank = 0;
                }
            }
        }

        $this->setMetaData();

		if($this->source == 'component' && (JRequest::getVar('view', 'category') != 'tags'))
	    {
    		igUtilityHelper::writeBreadcrumbs($this->category);
    	}

        if( ($this->profile->allow_comments == 1 || $this->profile->lbox_allow_comments == 1) && $this->params->get('comments-permission', 'registered') == 'recaptcha')
        {
            JPluginHelper::importPlugin('captcha');
            $dispatcher = JDispatcher::getInstance();
            $dispatcher->trigger('onInit', 'dynamic_recaptcha_1');
            $this->recaptcha = $dispatcher->trigger('onDisplay', array(null, 'dynamic_recaptcha_1', 'class=""'));
        }

	    parent::display('main');
	}

	function setMetaData($onlyFramework=false)
	{
		$document = JFactory::getDocument();
		$app = JFactory::getApplication();

        if(IG_J30)
        {
            JHtml::_('jquery.framework');
        }
        else
        {
            if($this->params->get('gallery_include_jquery', 0) == 1)
            {
                $document->addScript(JURI::root(true).'/media/com_igallery/plupload/js/jquery.js');
            }
        }

        $document->addStyleSheet(JURI::root(true).'/media/com_igallery/css/lib-42.css');
        $document->addStyleSheet(JURI::root(true).'/media/com_igallery/css/ignitegallery-42.css');
        $document->addScript(JURI::root(true).'/media/com_igallery/js/lib-42.js');
        $document->addScript(JURI::root(true).'/media/com_igallery/js/ignitegallery-42.js');

        if($onlyFramework==false)
        {
            $metaData = $this->getMetaData();

            if(isset($metaData['title']))
            {
                if( $app->getCfg('sitename_pagetitles', 0) == 1 )
                {
                    $pageTitle = JText::sprintf('JPAGETITLE', $app->getCfg('sitename'), $metaData['title']);
                }
                elseif($app->getCfg('sitename_pagetitles', 0) == 2)
                {
                    $pageTitle = JText::sprintf('JPAGETITLE', $metaData['title'], $app->getCfg('sitename'));
                }
                else
                {
                    $pageTitle = $metaData['title'];
                }

                $document->addCustomTag('<meta property="og:title" content="'.$pageTitle.'" />');
                $document->setTitle($pageTitle);

            }

            if(isset($metaData['description']))
            {
                $description = substr( JFilterOutput::cleanText($metaData['description']), 0, 200 );
                $document->setDescription($description);

                $ogDescription = substr( strip_tags( str_replace('"','\'',html_entity_decode($metaData['description'], ENT_QUOTES, 'UTF-8') ) ), 0, 200 );
                $document->addCustomTag('<meta property="og:description" content="'.$ogDescription.'" />');
            }

            if(isset($metaData['image']))
            {
                $metaTag = '<meta property="og:image" content="'.$metaData['image'].'" />';
                $document->addCustomTag($metaTag);

                if(isset($metaData['imageWidth']))
                {
                    $metaTag = '<meta property="og:image:width" content="'.$metaData['imageWidth'].'" />';
                    $document->addCustomTag($metaTag);
                }
                if(isset($metaData['imageHeight']))
                {
                    $metaTag = '<meta property="og:image:height" content="'.$metaData['imageHeight'].'" />';
                    $document->addCustomTag($metaTag);
                }
            }
        }
	}

	function getMetaData()
	{
		$metaData = array();

        if( empty($this->ajaxUrlImageName) )
        {
            if(!empty($this->urlImageName))
            {
                $this->ajaxUrlImageName = $this->urlImageName;
            }
        }

		if(!empty($this->ajaxUrlImageName) && !empty($this->photoList))
		{
			for($i=0; $i<count($this->photoList); $i++)
			{
				$fileNameNoExt = JFile::stripExt($this->photoList[$i]->filename);
				$fileNameNoRef = substr($fileNameNoExt, 0, strpos($fileNameNoExt, '-') );

				if( $fileNameNoRef == $this->ajaxUrlImageName)
				{
					$this->activeImage = $i;
					$metaData['image'] = IG_IMAGE_HTML_RESIZE_ABSOLUTE.$this->lboxFiles[$i]['folderName'].'/'.$this->lboxFiles[$i]['fullFileName'];
                    $metaData['imageWidth'] = $this->lboxFiles[$i]['width'];
                    $metaData['imageHeight'] = $this->lboxFiles[$i]['height'];

					if(!empty($this->photoList[$i]->alt_text))
					{
						$metaData['title'] = $this->photoList[$i]->alt_text;
					}

					if(!empty($this->photoList[$i]->description))
					{
						$metaData['description'] = $this->photoList[$i]->description;
					}

					break;
				}
			}
		}

		if($this->source == 'component')
	    {
			if(!isset($metaData['title']) && strlen($this->category->page_title) > 1)
			{
				$metaData['title'] = $this->category->page_title;
			}

			if(!isset($metaData['title']) && strlen($this->category->name) > 1)
			{
				$metaData['title'] = $this->category->name;
			}


			if(!isset($metaData['description']) && strlen($this->category->metadesc) > 1)
			{
				$metaData['description'] = 	$this->category->metadesc;
			}

			if(!isset($metaData['description']) && strlen($this->category->gallery_description) > 1)
			{
				$metaData['description'] = 	$this->category->gallery_description;
			}

            if( !isset($metaData['image']) )
            {
                if(isset($this->lboxFiles[0]))
                {
                    $metaData['image'] = IG_IMAGE_HTML_RESIZE_ABSOLUTE.$this->lboxFiles[0]['folderName'].'/'.$this->lboxFiles[0]['fullFileName'];
                }
                else if(isset($this->mainFiles[0]))
                {
                    $metaData['image'] = IG_IMAGE_HTML_RESIZE_ABSOLUTE.$this->mainFiles[0]['folderName'].'/'.$this->mainFiles[0]['fullFileName'];
                }
            }
		}

		return $metaData;
	}

    function removeCanonical()
	{
		$document = JFactory::getDocument();

		foreach($document->_links as $key => $value)
		{
			if($value['relation'] == 'canonical')
			{
				unset($document->_links[$key]);
			}
		}

	}



}

class igViewcategory extends igalleryViewcategory{}
